<template>
  <!-- eslint-disable -->
  <div class="hello">
    <h1>ddddddddd</h1>
    <button id="enableNotifications">
      Notification
    </button>
    <div>
      <button @click="install">
          install
      </button>
    </div>
  </div>
</template>

<script>
/* eslint-disable */
// let notificationButton = document.getElementById("enableNotifications");
let swRegistration = null;

export default {
  name: "HelloWorld",
  props: {
    msg: String,
  },
  data(){
    return {
      deferredPrompt: null
      // serviceWorker : ""
    }
  },

  mounted () {
    this.initializeApp()
  },
  created() {
    window.addEventListener("beforeinstallprompt", (e) => {
      e.preventDefault();
      // Stash the event so it can be triggered later.
      this.deferredPrompt = e;
    });
  },

  methods : {
    async install() {
      this.deferredPrompt.prompt();
    },
    initializeApp () {
      if ("serviceWorker" in navigator && "PushManager" in window) {
        console.log("Service Worker and Push is supported");

        //Register the service worker
        navigator.serviceWorker
          .register("../service-worker.js")
          .then(swReg => {
            console.log("Service Worker is registered", swReg);

            swRegistration = swReg;
            console.log(swRegistration,"--swRegistration--");
            this.initializeUi();
          })
          .catch(error => {
            console.error("Service Worker Error", error);
          });
      } else {
        let notificationButton = document.getElementById("enableNotifications");
        console.warn("Push messaging is not supported");
        notificationButton.textContent = "Push Not Supported";
      }
    },

    initializeUi() {
      let notificationButton = document.getElementById("enableNotifications");
      notificationButton.addEventListener("click", () => {
   
      });
      setInterval(() => {
             this.displayNotification();
      }, 5000);
    },

    displayNotification() {
      if (window.Notification && Notification.permission === "granted") {
        this.notification();
      }
      // If the user hasn't told if he wants to be notified or not
      // Note: because of Chrome, we are not sure the permission property
      // is set, therefore it's unsafe to check for the "default" value.
      else if (window.Notification && Notification.permission !== "denied") {
        Notification.requestPermission(status => {
          if (status === "granted") {
            this.notification();
          } else {
            alert("You denied or dismissed permissions to notifications.");
          }
        });
      } else {
        // If the user refuses to get notified
        alert(
          "You denied permissions to notifications. Please go to your browser or phone setting to allow notifications."
        );
      }
    },

    notification() {
      const options = {
        body: "Testing Our Notification",
        icon: ""
      };
      swRegistration.showNotification("PWA Notification!", options);
    }
  }
  // created:{
    
  // }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
